﻿' -----------------------------------------------------------------------------------------
'
' SortierAnlage.vb                                                  Ulrich Müller   2.02.08
'                                                                   PCS1700 VB 2005 Express
' Sortieranlage aus Experimentierbuch Profi Computing 36069 von 1991
' MainThread entält die Initialisierung und die Bandsteuerung nach Größe
' Der Thread Vereinzler übernimmt die Vereinzlung der Teile
'     Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports System.Threading
Imports FishFace40

Public Class frmSortMain

  Const mSortBand As Out = Out.M1
  Const eBandImpuls As Inp = Inp.I5
  Const mTransportBand As Out = Out.M2
  Const eLSchrankeHoch As Inp = Inp.I3
  Const eLschrankeNieder As Inp = Inp.I4
  Const mSchieber As Out = Out.M3
  Const eSchieberVorn As Inp = Inp.I1
  Const eSchieberHintenF As Inp = Inp.I2
  Const mLSchrankeLampe As Out = Out.M4

  Dim ft As New FishFace()
  Dim ve As Thread

  Private Sub Action()
    ft.SetMotor(mLSchrankeLampe, Dir.Ein)
    ft.Pause(1000)
    ft.SetMotor(mTransportBand, Dir.Links, Speed.Half)
    ve = New Thread(New ThreadStart(AddressOf Vereinzler))
    ve.IsBackground = True
    ve.Start()
    Do
      If Not ft.GetInput(eLSchrankeHoch) Then
        ft.SetMotor(mSortBand, Dir.Rechts)
        ft.WaitForChange(eBandImpuls, 20)
        ft.SetMotor(mSortBand, Dir.Aus)
      ElseIf Not ft.GetInput(eLschrankeNieder) Then
        ft.SetMotor(mSortBand, Dir.Links)
        ft.WaitForChange(eBandImpuls, 20)
        ft.SetMotor(mSortBand, Dir.Aus)
      End If
    Loop Until ft.Finish()
  End Sub

  Private Sub Vereinzler()
    Do
      ft.SetMotor(mSchieber, Dir.Rechts)
      ft.WaitForInput(eSchieberHintenF, False)
      ft.SetMotor(mSchieber, Dir.Links)
      ft.WaitForInput(eSchieberVorn)
      ft.SetMotor(mSchieber, Dir.Aus)
      ft.WaitForInput(eLschrankeNieder, False)
    Loop Until ft.Finish()
  End Sub
#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub ManBeispiele_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub

  Private Sub ManBeispiele_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region
End Class
